window.zs = window.zs || {};
(function (exports, cc) {
    'use strict';

    class Native {

        /**console.warn 缩写接口 */
        static log(...agrs) {
            if (this.DEBUG) {
                console.warn(`cc ${this.name} jsb call java : `, ...agrs);
            }
        }

        /**初始化 init */
        static init() {
            this.log(this.init.name);
        }

        /**
         * js调用java原生接口集合
         * @param {*} funName 需要调用java层的方法名
         * @param {*} getParams 返回的参数类型示例 ["111",111,true] 注意这个是函数return返回 一般没啥用     回调返回在java处理;
         * @param {*} backFunName 回调的方法名必须得是能在 window 上获取的静态函数(方法)名
         * @param {*} toParams 参数，一个一个传进来非数组
         */
        static jsbCall(funName, backFunName, getParams, ...toParams) {
            var type = "(";
            toParams = toParams || [];
            getParams = getParams || [];
            backFunName && toParams.splice(0, 0, backFunName);
            type = this.getType(type, toParams);
            type += ")";
            if (!getParams.length) type += "V";
            type = this.getType(type, getParams);
            if (toParams.length) {
                jsb.reflection.callStaticMethod(this.classPath, funName, type, ...toParams);
            }
            else {
                jsb.reflection.callStaticMethod(this.classPath, funName, type);
            }
            console.log("调用方法" + this.classPath, funName, type, backFunName, toParams);
        }

        static getType(typeNow, arr) {
            if (!arr || !arr.length) return typeNow;
            arr.forEach(param => {
                if (typeof param == "number") {
                    typeNow += this.signType.int;
                }
                else if (typeof param == "boolean") {
                    typeNow += this.signType.boolean;
                }
                else {
                    typeNow += this.signType.string;
                }
            });
            return typeNow;
        }

        static completedVideoFunc = null;
        static interuptVideoFunc = null;
        static errorVideoFunc = null;
        static videoTag = "";

        /**播放视频 */
        static playVideo(completedFunc, interuptFunc, errorFunc,videoTag) {
            this.completedVideoFunc = completedFunc;
            this.interuptVideoFunc = interuptFunc;
            this.errorVideoFunc = errorFunc;
            this.videoTag = videoTag;
            if (this.isReady) {
                this.jsbCall("openAwardVideo");
            } else {
                this.log("openAwardVideo");
                if (errorFunc) {
                    errorFunc();
                }
                //清空所有回调
                this.completedVideoFunc = this.interuptVideoFunc = this.errorVideoFunc = null;
            }
        }

        static showRewardVideo(tag, cb, fcb) {
            this.getConfig("zs_version",(key_zsversion)=>{
                if(key_zsversion == 1){
                    this.getConfig("zs_video_native_switch", (key) => {
                        if (key == 1) {
                            this.autoJumpFeed(cb, fcb);
                        }
                        else {
                            this.playVideo(cb, () => {
                            }, fcb);
                        }
                    })
                }else{
                    this.playVideo(cb, () => {
                    }, fcb);
                }
            })
            
        }
        /**视频回调 */
        static onVideoCloseHandler(resultJson) {
            console.error("视频完成 : ", resultJson);
            let result = resultJson.isEnded;
            if (result == true) {
                console.log("coco-视频统计:" + this.videoTag);
                zs.Native.eventTrack("video_success_" + this.videoTag);
                if (this.completedVideoFunc) {
                    this.completedVideoFunc();
                }
            } else {
                if (this.errorVideoFunc) {
                    this.errorVideoFunc();
                }
            }
            this.completedVideoFunc = this.interuptVideoFunc = this.errorVideoFunc = null;
        }

        static jumpSucFunc = null;
        static jumpFailFunc = null;
        static inTime = false;
        static autoJumpFeed(suc, fail) {
            if (this.inTime) return;
            setTimeout(() => {
                this.inTime = false;
            }, 3000);
            this.inTime = true;
            this.jumpSucFunc = suc;
            this.jumpFailFunc = fail;
            if (this.isReady) {
                this.jsbCall("autoJumpFeed");
            } else {
                suc && suc();
                this.log("编辑器autoJumpFeed");
            }
        }

        static onAutoJumpFinish(resultJson) {
            let result = resultJson.success;
            console.log("自动跳转结束" + result);
            if (result == true) {
                this.jumpSucFunc && this.jumpSucFunc();
            } else {
                this.jumpFailFunc && this.jumpFailFunc();
            }
            this.jumpSucFunc = this.jumpFailFunc = null;
        }

        
        /**视频回调 */
        static onVideoCloseHandler(resultJson) {
            console.error("视频完成 : ", resultJson);
            let result = resultJson.isEnded;
            if(result == true){
                console.log("coco-视频统计:"+this.videoTag);
                zs.Native.eventTrack("video_success_"+this.videoTag);
                if (this.completedVideoFunc) {
                    this.completedVideoFunc();
                }
            }else{
                if (this.errorVideoFunc) {
                    this.errorVideoFunc();
                }
            }
            this.completedVideoFunc = this.interuptVideoFunc = this.errorVideoFunc = null;
        }

        static feedCloseFunc = null;

        static setFeedCloseCallback(func){
            this.feedCloseFunc = func;
        }

        /**自渲染关闭回调 */
        static onFeedCloseHandler() {
            console.error("自渲染关闭");
            if(this.feedCloseFunc){
                this.feedCloseFunc();
            }
        }

        /**
         * 页面事件触发
         */
         static handlerAd(eventName){
            console.log("coco-  handlerAd:"+eventName);
            if (this.isReady){
                this.jsbCall("handlerAd", null,null,eventName);
            }else{
                this.log("编辑器handlerAd："+eventName);
            }
        }

        /**
         * 自定义事件
         */
        static eventTrack(eventName){
            console.log("coco- eventTrack:"+eventName);
            if (this.isReady){
                this.jsbCall("eventTrack", null,null,eventName);
            }else{
                this.log("编辑器eventTrack："+eventName);
            }
        }


        static getCallBack = null;
        /**获取配置 */
        static getConfig(confName, callBack) {
            if (!this.isReady) {
                callBack && callBack();
                return;
            }
            this.getCallBack = callBack;
            this.jsbCall("getConfig", null, ["1"], confName);

        }

        static onGetKey(data) {
            this.getCallBack && this.getCallBack(data);
            this.getCallBack = null;
        }

    }

    /**android 层代码的路径 */
    Native.classPath = "com/coco/ad/AdJsBridge";
    /** java 签名返回值类型 */
    Native.signType = {
        int: "I",
        float: "F",
        boolean: "Z",
        string: "Ljava/lang/String;",
    }
    //是否是原生平台 -- 兼容laya
    Native.isReady = CC_JSB;
    Native.DEBUG = true;

    exports.Native = Native;
})(window.zs = window.zs || {}, cc);